### A free/open-source library for quantitative finance

Public Member Functions | Protected Attributes
InterestRateIndex Class Reference

base class for interest rate indexes More...

`#include <ql/indexes/interestrateindex.hpp>`

Inheritance diagram for InterestRateIndex:
[legend]

List of all members.

## Public Member Functions

| InterestRateIndex (const std::string &familyName, const Period &tenor, Natural settlementDays, const Currency &currency, const Calendar &fixingCalendar, const DayCounter &dayCounter)
Index interface
std::string | name () const
| Returns the name of the index.
Calendar | fixingCalendar () const
| returns the calendar defining valid fixing dates
bool | isValidFixingDate (const Date &fixingDate) const
| returns TRUE if the fixing date is a valid one
Rate | fixing (const Date &fixingDate, bool forecastTodaysFixing=false) const
| returns the fixing at the given date
Observer interface
void | update ()
Inspectors
std::string | familyName () const
Period | tenor () const
Natural | fixingDays () const
Date | fixingDate (const Date &valueDate) const
const Currency & | currency () const
const DayCounter & | dayCounter () const
Date calculations
These method can be overridden to implement particular conventions (e.g. EurLibor)
virtual Date | valueDate (const Date &fixingDate) const
virtual Date | maturityDate (const Date &valueDate) const =0
Fixing calculations
virtual Rate | forecastFixing (const Date &fixingDate) const =0
| It can be overridden to implement particular conventions.
Rate | pastFixing (const Date &fixingDate) const

## Protected Attributes

std::string | familyName_
Period | tenor_
Natural | fixingDays_
Currency | currency_
DayCounter | dayCounter_

## Detailed Description

base class for interest rate indexes

Possible enhancements:
  add methods returning InterestRate

## Member Function Documentation

std::string name | ( |  | ) | const`[virtual]`

Returns the name of the index.

Warning:
  This method is used for output and comparison between indexes. It is not meant to be used for writing switch-on-type code.

Implements Index.

Reimplemented in BMAIndex.

Rate fixing | ( | const Date & | fixingDate,
|  | bool | forecastTodaysFixing = `false`
| ) |  | const`[virtual]`

returns the fixing at the given date

the date passed as arguments must be the actual calendar date of the fixing; no settlement days must be used.

Implements Index.

void update | ( |  | ) | `[virtual]`

This method must be implemented in derived classes. An instance of Observer does not call this method directly: instead, it will be called by the observables the instance registered with when they need to notify any changes.

Implements Observer.